| # This program is free software: you can redistribute it and/or modify |
| # it under the terms of the GNU General Public License as published by |
| # the Free Software Foundation, either version 3 of the License, or |
| # (at your option) any later version. |
| # |
| # This program is distributed in the hope that it will be useful, |
| # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| # GNU General Public License for more details. |
| # |
| # You should have received a copy of the GNU General Public License |
| # along with this program. If not, see <http://www.gnu.org/licenses/>. |
| # |
| : ${TMPDIR:=/var/tmp} |
| TMPFILE=$TMPDIR/exitcode |
| trap 'rm -f $TMPFILE' 0 |
| |
| rm -f $TMPFILE |
| set -e |
| # we normalize the exit code to accommodate false returning 255 on Solaris |
| exit_handler() { echo "exit code: $(( $? != 0 ))" ; touch $TMPFILE; } |
| false() { ! :; } |
| notfound() { nosuchcommand ; } |
| syntaxerror() { !:; } |
| |
| main() |
| {( |
| trap exit_handler 0 |
| "$@" >> /dev/null 2>&1 |
| )} |
| main "$@" |
| echo "after main: should not get here" |